module type T = sig
  type elt 
  type t 
  val empty: t
  val add: elt -> t -> t
  val elems: t -> elt list
  val fold: (elt -> 'a -> 'a) -> t -> 'a -> 'a
end

module Make (E : Set.OrderedType) : T with type elt = E.t

module Product (S1: T) (S2: T) :
sig
  module E : Set.OrderedType with type t = S1.elt * S2.elt
  include T with type elt = E.t and type t = Make(E).t
  val product: S1.t -> S2.t -> t
end
  
