module type Attr = sig type t end

module type T = sig
  type elt 
  type attr
  type t 
  module S: Myset.T with type elt = elt
  val empty: t
  val add: elt * attr -> t -> t
  val elems: t -> (elt * attr) list
  val set_of: t -> S.t
  val fold: (elt * attr -> 'a -> 'a) -> t -> 'a -> 'a
end

module Make (E : Set.OrderedType) (A: Attr) : T with type elt = E.t and type attr = A.t

module Product (S1: T) (S2: T) :
sig
  include T with type elt = S1.elt * S2.elt and type attr = S1.attr * S2.attr
  val product: S1.t -> S2.t -> t
end
  
